<?php 

/**
 Setup for Jivelite Squeezebox Visualisation
 
 @Copyright 2014 Stefan Rick
 @author Stefan Rick
 Mail: stefan@rick-software.de
 Web: http://www.netzberater.de
 
 */

class Jivelite_Setup extends Service {	
	protected $pname = 'jivelite';
	public $viewname = 'Jivelite';
	public $scriptPath = '';
	private $lxde_config = '';
	
	public function __construct(){		
		parent::__construct();		
		$this->registerLocale(dirname(__FILE__).'/../locale', 'jivelite');
		$this->pluginname = _('Jivelite');				
		$this->scriptPath = dirname(__FILE__).'/../scripts/';
		
		if($this->checkLicense(true) == false)
			return true;
		
		if($_GET['ajax'] == 1 && $_GET['action'] == 'install'){
			//Function to get Progress of Installation
			$this->_install(1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
		if($_GET['ajax'] == 1 && $_GET['action'] == 'installcec'){
			//Function to get Progress of Installation
			$this->_installcec(1);
			ob_end_clean();
			echo implode('<br />', $this->view->message);
			ob_flush();
			die();
		}
	   
		$this->getAutohidePanel();
		
		if(isset($_GET['action'])){
			if($_GET['action'] == 'start'){			
				//Check auf Lightdm
				if($_GET['reinitx'] != FALSE){					
					$script = array('/etc/init.d/lightdm stop > /dev/null 2>&1 &','sleep 2', '/etc/init.d/lightdm start > /dev/null 2>&1 &');
					$output = $this->writeDynamicScript($script);
					sleep(5);
					$this->view->message[] = _t('Restart Desktop-Manager completed (initialized Display)');
				}
				if($this->getSystemUser() == 'pi'){
					//Check for existing XSesssion
					$checkX = $this->writeDynamicScript(array('ps -Al | grep xinit | wc -l'));
					if(trim($checkX) == 0){
						$this->writeDynamicScript(array('export DISPLAY=\':0\';su -l pi -c startx > /dev/null 2>&1 &'));
						sleep(5);
					}
					$this->view->message[] = $this->start($this->pname, 'export DISPLAY=\':0\';sudo -u pi -H /opt/jivelite/jivelite/bin/jivelite > /tmp/jivelite.txt 2>&1 &', '', $rootstart = true, $background = '/tmp/jivelite.txt');
				}else{
					$display = 0;
					if($this->getHardwareInfo() == 'ODROIDC'){
						// Display 0 or Display 1 (LCD Screen seems to be Display 1)
						$display = (trim(shell_exec('ls /tmp/.X11-unix | grep X1 | wc -l')) == 1) ? 1 : 0;					
					}				
					$this->view->message[] = $this->start($this->pname, 'export DISPLAY=\':'.$display.'\';sudo -u odroid -H /opt/jivelite/jivelite/bin/jivelite > /tmp/jivelite.txt 2>&1 &', '', $rootstart = true, $background = '/tmp/jivelite.txt');
				}
			}
			
			if($_GET['action'] == 'stop'){			
				$this->view->message[] = $this->stop('jivelite', 'sudo kill -9 $PID');
				if($this->getSystemUser() == 'pi'){
					$this->writeDynamicScript(array('killall lxsession; killall openbox; killall xinit'));
				}
			}
			
			if($_GET['action'] == 'save'){							
				$this->selectAutostart(isset($_GET['autostart']) ? 1 : 0);
				$this->setAutohidePanel(isset($_GET['autohidepanel']) ? 1 : 0);
				$this->getAutohidePanel();
			}
			if($_GET['action'] == 'resetjivelite'){
				$this->_resetSettings();
			}
			if($_GET['action'] == 'disablepoweroff'){
				$this->_disablepoweroff();
			}
			if($_GET['action'] == 'installcec'){
				$this->_installcec();
			}
			if($_GET['action'] == 'enableShutdownControl'){
				$this->_enableShutdownControl();
			}
			if($_GET['action'] == 'install'){
				$this->stop('jivelite', 'sudo kill -9 $PID');
				if($this->getSystemUser() == 'pi'){
					$this->writeDynamicScript(array('killall lxsession'));
				}
				$this->_install();
			}else{
				$this->getJLVersion();
			}
			if($_GET['action'] == 'skininstall'){
				$this->skinInstall();
			}
		}else{
			$this->getJLVersion();
		}
		$this->getAllLogs();
		$this->view->autostart = $this->checkAutostart($this->pname, true);
		$this->view->pid = $this->status($this->pname);			
		$this->showHelpSidebar();
		$this->cecHandler();
	}	
	
	/**
	 * separate Handling of CEC
	 * @return boolean
	 */
	public function cecHandler(){
		if(isset($_REQUEST['action'])){
			if($_REQUEST['action'] == 'startcec'){
				$this->view->message[] = $this->start('libcec-daemon', '/usr/local/bin/libcec-daemon > /tmp/libcec-daemon.txt 2>&1 &', '', $rootstart = true, $background = '/tmp/libcec-daemon.txt');
			}
			if($_REQUEST['action'] == 'savecec'){
				$this->selectAutostart(isset($_REQUEST['autostartcec']) ? 1 : 0, true, 'LIBCEC_AUTOSTART');
			}
		}
		$this->cec = new stdClass();
		$this->cec->autostart = $this->checkAutostart('LIBCEC_AUTOSTART', true);
		$this->cec->installed = file_exists('/usr/local/bin/libcec-daemon');
		$this->cec->pid = $this->status('libcec-daemon');
		return true;
	}
	
	/**
	 * try to get Version / at least show if it is installed
	 * @return boolean
	 */
	private function getJLVersion(){						
		if(file_exists('/opt/jivelite/jivelite/bin/jivelite'))
			$this->view->installed = true;
		else{
			$this->view->message[] = _t('Jivelite is not installed - start installation by clicking on INSTALL button at the end of the page!');
		}
		
		return true;
	}
	
	/**
	 * in Case something broke Jivelite
	 */
	private function _resetSettings(){
		$this->writeDynamicScript(array('rm -R /home/'.$this->getSystemUser().'/.jivelite'));
		$this->view->message[] = _t('RESET SUCCESSFUL - Please restart Jivelite');
		return true;
	}
	
	private function _disablepoweroff(){
		$this->writeDynamicScript(array(''));
		$this->view->message[] = _t('PATCH SUCCESSFUL - Please restart Jivelite');
		return true;
	}	
	
	private function _enableShutdownControl(){
		$this->writeDynamicScript(array('mkdir -p /opt/jivelite/jivelite/share/jive/applets/ShutdownControl; cp '.$this->scriptPath.'ShutdownControl/* /opt/jivelite/jivelite/share/jive/applets/ShutdownControl'));
		$this->view->message[] = _t('PATCH SUCCESSFUL - Please restart Jivelite');
		return true;
	}
	
	private function _install($ajax = 0){
		if($ajax == 0){
			if($this->getProgressWithAjax('/opt/max2play/cache/install_jivelite.txt', 1, 1)){
				if($_REQUEST['installer'] == 'compile'){
					$shellanswer = $this->writeDynamicScript(array($this->scriptPath."install_jivelite.sh ".$this->scriptPath." >> /opt/max2play/cache/install_jivelite.txt 2>&1 &"), false, true);
				}else{
					$this->view->message[] = "Install Version Max2Play Build jivelite-m2p";
					$shellanswer = $this->writeDynamicScript(array($this->scriptPath."install_jivelite.sh ".$this->scriptPath." binary >> /opt/max2play/cache/install_jivelite.txt 2>&1 &"), false, true);
				}
			}
		}else{
			$status = $this->getProgressWithAjax('/opt/max2play/cache/install_jivelite.txt', 0, 1, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'finished') !== FALSE){
				//Finished Progress - did not delete progressfile yet				
				$this->view->message[] = _t('INSTALL SUCCESSFUL');
				shell_exec('rm /opt/max2play/cache/install_jivelite.txt');				
			}
		}			
	 	return true;
	}
	
	private function _installcec($ajax = 0){
		if($ajax == 0){
			if($this->getProgressWithAjax('/opt/max2play/cache/install_jivelite.txt', 1, 1)){
				$shellanswer = $this->writeDynamicScript(array($this->scriptPath."install_cec.sh ".$this->scriptPath." >> /opt/max2play/cache/install_jivelite.txt 2>&1 &"), false, true);				
			}
		}else{
			$status = $this->getProgressWithAjax('/opt/max2play/cache/install_jivelite.txt', 0, 1, 30);
			$this->view->message[] = nl2br($status);
			if(strpos($status, 'finished') !== FALSE){
				//Finished Progress - did not delete progressfile yet
				$this->view->message[] = _t('INSTALL SUCCESSFUL');
				shell_exec('rm /opt/max2play/cache/install_jivelite.txt');
			}
		}
		return true;
	}
	
	/**
	 * function to get autohide value for panel
	 */
	private function getAutohidePanel(){
		if($this->getHardwareInfo() == 'Raspberry PI'){
		    $this->lxde_config = trim($this->writeDynamicScript(array('ls /home/pi/.config/openbox/ | grep "lxde"')));
		    if($this->lxde_config != '')
		        $file = '/home/pi/.config/openbox/'.$this->lxde_config;
			$this->view->autohidepanel = trim($this->writeDynamicScript(array('grep -i "jivelite" '.$file.' | wc -l')));
			if($this->view->autohidepanel > 1)
				$this->view->autohidepanel = 1;
		}else{				
			$autohide=$this->writeDynamicScript(array('grep -a autohide /home/odroid/.config/lxpanel/Lubuntu/panels/panel'));
			if(strpos($autohide, 'autohide=0') !== FALSE){
				$this->view->autohidepanel = 0;
			}else{
				$this->view->autohidepanel = 1;
			}
		}
		
		return true;
	}
	
	/**
	 * function to remove Taskbar with autohide
	 */
	private function setAutohidePanel($hide = 0){
		$this->getAutohidePanel();
		if($this->view->autohidepanel != $hide){
			if($this->getHardwareInfo() == 'Raspberry PI') {			    
			    if($this->lxde_config != '')
			        $file = '/home/pi/.config/openbox/'.$this->lxde_config;
				if(!isset($file)){
					$this->view->message[] = _t('Function not available - Desktop Manager Files not found - You need to start Jivelite one time before this function can be used.');
					return true;
				}
				if($hide == 1)
					$this->writeDynamicScript(array('sed -i \'s@<applications>@<applications>\\n<application name="jivelite"><fullscreen>yes</fullscreen><maximized>true</maximized><layer>above</layer><focus>yes</focus></application>@\' '.$file)); 				
				else 
					$this->writeDynamicScript(array('sed -i \'s@<application name="jivelite".*$@@\' '.$file));
			}else{
				//set new value & restart			
				$this->writeDynamicScript(array('sed -i \'s/autohide='.$this->view->autohidepanel.'/autohide='.$hide.'/\' /home/odroid/.config/lxpanel/Lubuntu/panels/panel',
											'export DISPLAY=\':0\';sudo --user=odroid -H lxpanelctl restart'));
			}			
			$this->view->message[] = _t('Updated Autohide Panel Setting to').' '.$hide;
		}
		return true;
	}
	
	public function showHelpSidebar(){
		global $helpSidebar;
		$helpSidebar['title'] = _t('Help - Jivelite');
		$helpSidebar['content'] = _t('<ul><li><a href="https://youtu.be/7LW1cQyT9T0" target="blank">Watch a video showing Jivelite on Max2Play</a></li><li>Installing Jivelite takes some time depending on your device! Please have Javascript enabled in your browser to see the status of the installation.</li><li>Once running Jivelite you can use the VNC-Server Addon for Max2Play to control the Desktop and Jivelite from another computer!</li></ul>');
		return true;
	}
	
	public function skinInstall(){
		if($_REQUEST['skinchoose'] == '1024x600patch'){
			$this->view->message[] = nl2br($this->writeDynamicScript(array("patch /opt/jivelite/jivelite/share/jive/applets/JogglerSkin/JogglerSkinApplet.lua < ".$this->scriptPath."JogglerPatches/JogglerSkinApplet.lua.m2p.1024x600.patch")));
		}
		elseif($_REQUEST['skinchoose'] == '1280x800patch'){
			$this->view->message[] = nl2br($this->writeDynamicScript(array("patch /opt/jivelite/jivelite/share/jive/applets/JogglerSkin/JogglerSkinApplet.lua < ".$this->scriptPath."JogglerPatches/JogglerSkinApplet.lua.m2p.1280x800.patch")));
		}
		else{
			$this->view->message[] = $this->writeDynamicScript(array($this->scriptPath."addskin_jivelite.sh"));
			$this->view->message[] = $this->writeDynamicScript(array('sed -i "s/rpi_backlight/*/" /opt/jivelite/jivelite/share/jive/applets/BlankScreenSaver/BlankScreenSaverApplet.lua'));
			$this->view->message[] = _t('Backlight Update applied to BlankScreensaver for Display.');
			$this->view->message[] = _t('New skin installed. Restart Jivelite and choose new skin.');
		}
		return true;
	}
	
	private function getAllLogs(){
		$out = array();
		//$out['LIBCEC-DAEMON'] = shell_exec('ps -Al | grep libcec-daemon');		
		$this->view->debug = $out;
		return true;
	}
	
}

$jl = new Jivelite_Setup();

include_once(dirname(__FILE__).'/../view/setup.php');

