#!/bin/bash
if [ -e /home/pi ]; then
	USER=pi
else
	USER=odroid
fi
pushd /opt/
git clone https://github.com/ysop/jivelite-qvga-touch-rpi.git
cp -R /opt/jivelite-qvga-touch-rpi/share/jive/applets/QVGATouchSkin/ /opt/jivelite/jivelite/share/jive/applets/
cp -f /opt/jivelite-qvga-touch-rpi/share/jive/jive/ui/Keyboard.lua /opt/jivelite/jivelite/share/jive/jive/ui/Keyboard.lua

# Fix for VUMeter in QVGATouchskin
CURRENTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
cp $CURRENTDIR/JogglerPatches/images/UNOFFICIAL/VUMeter/vu_analog_25seq_m2p_b_320.png /opt/jivelite/jivelite/share/jive/applets/QVGATouchSkin/images/UNOFFICIAL/VUMeter/vu_analog_25seq_b.png

# Change Skin in Jivelite -> make it default
if [ -e /home/$USER ]; then
  if [ -e /home/$USER/.jivelite/userpath/settings/ ]; then
	echo "settings = {skin=\"QVGATouchSkin\",}" > /home/$USER/.jivelite/userpath/settings/SelectSkin.lua
	chown -R $USER /home/$USER/.jivelite
	echo "Skin setting updated"
  else
	mkdir -p --mode=777 /home/$USER/.jivelite/userpath/settings	
	echo "settings = {skin=\"QVGATouchSkin\",}" > /home/$USER/.jivelite/userpath/settings/SelectSkin.lua
	chown -R $USER /home/$USER/.jivelite
	echo "Skin setting created"
  fi
fi

echo "finished";

