#!/bin/bash
# https://github.com/bramp/libcec-daemon
# https://www.raspberrypi.org/forums/viewtopic.php?f=29&t=70923
# Key Bindings: http://www.vdr-portal.de/board18-vdr-hardware/board98-arm-co/p1230756-gel%C3%B6st-hdmi-cec-bestimmte-tasten-der-fernbedienung-vom-tv-gehen-nicht/

apt-get update
apt-get install build-essential autoconf checkinstall -y
apt-get install libboost-program-options-dev libboost-thread-dev libboost-system-dev liblog4cplus-dev -y

# Build CEC for Raspberry
if [ "$1" == "buildcec" ]; then
	pushd /opt
	git clone https://github.com/mdrjr/libcec.git
	cd libcec
	./bootstrap
	./configure --with-rpi-include-path=/opt/vc/include --with-rpi-lib-path=/opt/vc/lib --enable-rpi
	make
	checkinstall


	# maybe better Alternative?
	#apt-get update
	#apt-get install cmake liblockdev1-dev libudev-dev libxrandr-dev python-dev swig -y
	#git clone https://github.com/Pulse-Eight/platform.git
	#mkdir platform/build
	#cd platform/build
	#cmake ..
	#make
	#make install
	#cd ../..
	#git clone https://github.com/Pulse-Eight/libcec.git
	#mkdir libcec/build
	#cd libcec/build
	#cmake -DRPI_INCLUDE_DIR=/opt/vc/include -DRPI_LIB_DIR=/opt/vc/lib ..
	#make -j4
	#make install
	#ldconfig
else
	# Get Compiled LibCEC from Max2Play CDN
	wget -O /opt/max2play/cache/libcec_2.1.0-1_armhf.deb shop.max2play.com/media/downloadable/currentversion/libcec_2.1.0-1_armhf.deb
	dpkg -i /opt/max2play/cache/libcec_2.1.0-1_armhf.deb
fi

ldconfig

# check 
cec-client -l

pushd /opt
#git clone git://github.com/hoffmannku/libcec-daemon.git
#set to fixed CEC_CLIENT_VERSION_CURRENT in src/libcec.cpp
git clone git://github.com/bramp/libcec-daemon.git
cd libcec-daemon/
./bootstrap && ./configure && make
echo "Set Compiler to 4.7 version"
apt-get install fonts-roboto javascript-common libhdhomerun1 libjs-jquery -y
apt-get install gcc-4.7 g++-4.7 -y
update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.6 60 --slave /usr/bin/g++ g++ /usr/bin/g++-4.6
update-alternatives --install /usr/bin/gcc gcc /usr/bin/gcc-4.7 40 --slave /usr/bin/g++ g++ /usr/bin/g++-4.7
echo "2" | update-alternatives --config gcc
./bootstrap && ./configure && make
make install

# execute libcec-daemon to test input
# Add libcec-daemon to autostart if not existing
if [ ! "$(grep -a 'LIBCEC_AUTOSTART' /etc/rc.local)" ]; then
	sed -i "s@^exit 0@if [ \"\$(grep -a 'LIBCEC_AUTOSTART=1' /opt/max2play/autostart.conf)\" ]; then /usr/local/bin/libcec-daemon; fi\nexit 0@" /etc/rc.local
fi
/usr/local/bin/libcec-daemon

echo "finished <b><a href='/plugins/jivelite/controller/Setup.php'>Click here to reload Page</a></b>";

exit 0