#!/bin/bash
apt-get update
apt-get install git libsdl1.2-dev libsdl-ttf2.0-dev libsdl-image1.2-dev libsdl-gfx1.2-dev libexpat1-dev --yes --force-yes
if [ ! -e /usr/lib/arm-linux-gnueabihf/libSDL_gfx.so.13 ]; then
	# Debian Jessie!
	ln -s /usr/lib/arm-linux-gnueabihf/libSDL_gfx.so /usr/lib/arm-linux-gnueabihf/libSDL_gfx.so.13
fi	
if [ "$2" == "binary" ]; then
	# create with pushd /opt && tar -cvzf /opt/max2play/cache/jivelite-m2p-07082017.tar.gz jivelite --exclude=.git
	echo "Install jivelite-m2p-07082017"
	wget cdn.max2play.com/binaries/jivelite-m2p-07082017.tar.gz -O /opt/max2play/cache/jivelite.tar.gz 
	tar -zxf /opt/max2play/cache/jivelite.tar.gz -C /opt 
	pushd /opt/jivelite/luajit-2.0/ 
	make install 
	ldconfig
else
	pushd /opt
	rm -r /opt/jivelite
	mkdir jivelite
	pushd /opt/jivelite/
	#git clone https://code.google.com/p/jivelite/
	git clone https://github.com/ralph-irving/jivelite.git
	# get correct resize.c - fixed
	# wget https://jivelite.googlecode.com/git/src/resize.c -O /opt/jivelite/jivelite/src/resize.c
	git clone http://luajit.org/git/luajit-2.0.git
	pushd /opt/jivelite/luajit-2.0/;make;make install;ldconfig
	pushd /opt/jivelite/jivelite
	make
	
	# Get Clock
	mkdir -p /opt/jivelite/jivelite/share/jive/applets/Clock
	cp $1/Clock/* /opt/jivelite/jivelite/share/jive/applets/Clock
	cp -R $1/Clock/images/* /opt/jivelite/jivelite/share/jive/applets/JogglerSkin/images/Clocks
	cp -R $1/Clock/images/* /opt/jivelite/jivelite/share/jive/applets/WQVGAsmallSkin/images/Clocks
	
	# Set Screensaver to deactivate on mouseclick for touchscreens
	sed -i 's@self:_setSSAllowedActions(true, {}, true)@--self:_setSSAllowedActions(true, {}, true)@' /opt/jivelite/jivelite/share/jive/applets/ScreenSavers/ScreenSaversApplet.lua
	
	echo "Add to autostart"
	# Parse Autostart for existing Jivelite
	existing=$(grep -a jivelite /opt/max2play/autostart.conf | wc -l)
	if [ "$existing" -lt "1" ]; then
		echo "jivelite=0" >> /opt/max2play/autostart.conf
	fi
	
	echo "Configure Jivelite"
	if [ -e /home/pi ]; then
		USER=pi
	else
		USER=odroid
	fi
	
	# Start Applet for Kodi
	mkdir -p /opt/jivelite/jivelite/share/jive/applets/KodiControl
	cp $1/KodiControl/* /opt/jivelite/jivelite/share/jive/applets/KodiControl
	
	if [ -e /home/$USER/.jivelite/userpath/settings/ ]; then
	  echo 'settings = {whenStopped="BlankScreenSaver:openScreensaver",whenPlaying="NowPlaying:openScreensaver",timeout=30000,whenOff="BlankScreenSaver:openScreensaver",}' > /home/$USER/.jivelite/userpath/settings/ScreenSavers.lua	  
	  echo "Jivelite Screensaver setting updated"
	  chown -R $USER /home/$USER/.jivelite
	else
	  mkdir -p --mode=777 /home/$USER/.jivelite/userpath/settings	
	  echo 'settings = {whenStopped="BlankScreenSaver:openScreensaver",whenPlaying="NowPlaying:openScreensaver",timeout=30000,whenOff="BlankScreenSaver:openScreensaver",}' > /home/$USER/.jivelite/userpath/settings/ScreenSavers.lua
	  chown -R $USER /home/$USER/.jivelite
	fi	
	
	
	#sudo --user=odroid echo "settings = {skin="HDGridSkin-1080",}" > /home/odroid/.jivelite/userpath/settings/SelectSkin.lua
	#sudo --user=odroid echo "settings = {setupDone=true,}" > /home/odroid/.jivelite/userpath/settings/SetupWelcome.lua
	#sudo --user=odroid echo "settings = {_AUTOUP=false,_LASTVER="0.1.0",}" > /home/odroid/.jivelite/userpath/settings/SetupAppletInstaller.lua
	#sudo --user=odroid echo "settings = {locale="DE",}" > /home/odroid/.jivelite/userpath/settings/SetupLanguage.lua
	
	# Clock and more from original sources and LUA Programming
	# http://wiki.slimdevices.com/index.php/Jive_Lua_source_code_conventions
	# http://svn.slimdevices.com/repos/jive/7.5/trunk/squeezeplay/src/squeezeplay/share/applets/Clock/ClockApplet.lua
	
	# Patch for 7" Display to disable Backlight on Blankscreensaver
	# Created with diff -crB BlankScreenSaverApplet.lua.1 BlankScreenSaverApplet.lua > backlight-off-blankscreen-jivelite.patch
	patch -f /opt/jivelite/jivelite/share/jive/applets/BlankScreenSaver/BlankScreenSaverApplet.lua $1/BlankScreenSaver/backlight-off-blankscreen-jivelite.patch
	
	# Patch Joggler Skin for: Quit, VUMeter, 1024" Touchdisplay, 1280" Touchdisplay
	# diff -crB JogglerSkinApplet.lua.ori JogglerSkinApplet.lua > JogglerSkinApplet.lua.m2p.1280x800.patch
	# diff -crB VUMeter.lua VUMeter.lua.m2p > VUMeterFix.m2p.patch
	# diff -crB QuitMeta.lua QuitMeta.lua.m2p > JogglerQuitFix.m2p.patch
	# CUSTOM depending on Display: patch -f /opt/jivelite/jivelite/share/jive/applets/JogglerSkin/JogglerSkinApplet.lua $1/JogglerPatches/JogglerSkinApplet.lua.m2p.1280x800.patch
	patch -f /opt/jivelite/jivelite/share/jive/applets/Quit/QuitMeta.lua $1/JogglerPatches/JogglerQuitFix.m2p.patch
	patch -f /opt/jivelite/jivelite/share/jive/jive/vis/VUMeter.lua $1/JogglerPatches/VUMeterFix.m2p.patch
	cp -R $1/JogglerPatches/images/* /opt/jivelite/jivelite/share/jive/applets/JogglerSkin/images/
		
fi


echo "finished <b><a href='/plugins/jivelite/controller/Setup.php'>Click here to reload Page</a></b>";

